' SUPERAS 
' Hitachi SH2 assembler by DamageX
' compiled with FreeBASIC
'
' to do:
' more thorough syntax checking
' tons more...
'
' leaving off the data size in a indexed-with-displacement mov turns it into
' an immediate mov with no error
' mov @(8,r14),r1 is assembled to mov #8,r1 :(
' change filler words for align.l into NOPs?
'

dim as ubyte a,b,comment,rs,rd,r,argsok,e,sr,lineend,localz,localu
dim i as integer
dim s as ushort
dim c as string*1
dim as uinteger w,x,y,z,ff1,ff2,ff3,ff4,l,labs,pcaddr,fileaddr,o,imm,argtype
dim as uinteger frefs,oldarg,ln
dim il(0 to 255) as ubyte
dim estr(0 to 1,0 to 20) as ubyte
dim esize(0 to 1) as ubyte
dim etype(0 to 1) as uinteger
dim ifile as string
dim ofile as string
dim bfile as string
dim lfile as string
dim labelnames(0 to 9999) as string*20
dim labelname as string*20
dim labeladdrs(0 to 9999) as uinteger
dim frefmode(0 to 9999) as ubyte        ' 1=absolute (ignore base)
dim frefbase(0 to 9999) as uinteger
dim frefaddr(0 to 9999) as uinteger
dim frefline(0 to 9999) as uinteger
dim freflabn(0 to 9999) as uinteger
dim opname as string*12
dim copybuf as string*4096

dim rnames(0 to 6) as string*4 => _
{ _
 "MACH", _
 "MACL", _
 "GBR ", _
 "PC  ", _
 "PR  ", _
 "SR  ", _
 "VBR " _
}

' 0 = no operands
' 1 = ops that take one register as operand
' 2 = ops that take two registers as operands
' 3 = ops that take a sys/cntrl reg as source
' 4 = setpc/pad/org
' 5 = end
' 6 = dc.b
' 7 = dc.w
' 8 = dc.l
' 9 = incbin
' A = ops with an 8-bit immediate
' B = ops with multiple formats (all are two operands...)
' C = ops that take a sys/cntrl reg as destination
' D = ops with an 8-bit PC-relative displacement
' E = ops with a 12-bit PC-relative displacement
' F = something that gets ignored (for instance, because I don`t know what it means)
' G = alignment
' H = IMOV pseudo-instruction
' I = IDATA (marks dumping ground for IMOV constants)

dim opset(0 to 102) as string*12 => _
{ _
 "ADD    B0", _
 "ADDC   23nmE", _
 "ADDV   23nmF", _
 "AND    B1", _
 "AND.B  ACDdd", _
 "BF     D8Bdd", _
 "BF/S   D8Fdd", _
 "BRA    EAddd", _
 "BRAF   10n23", _
 "BSR    EBddd", _
 "BSRF   10n03", _
 "BT     D89dd", _
 "BT/S   D8Ddd", _
 "CLRMAC 00028", _
 "CLRT   00008", _
 "CMP/EQ B2", _
 "CMP/GE 23nm3", _
 "CMP/GT 23nm7", _
 "CMP/HI 23nm6", _
 "CMP/HS 23nm2", _
 "CMP/PL 14n15", _
 "CMP/PZ 14n11", _
 "CMP/STR22nmC", _
 "DIV0S  22nm7", _
 "DIV0U  00019", _
 "DIV1   23nm4", _
 "DMULS.L23nmD", _
 "DMULU.L23nm5", _
 "DT     14n10", _
 "EXTS.B 26nmE", _
 "EXTS.W 26nmF", _
 "EXTU.B 26nmC", _
 "EXTU.W 26nmD", _
 "JMP    14n2B", _
 "JSR    14n0B", _
 "LDC    C", _
 "LDC.L  C", _
 "LDS    C", _
 "LDS.L  C", _
 "MAC.L  20nmF", _
 "MAC.W  24nmF", _
 "MOV.B  B3", _
 "MOV.W  B4", _
 "MOV.L  B5", _
 "MOVA   BA", _
 "MOVT   10n29", _
 "MOV    B6", _
 "MUL.L  20nm7", _
 "MULS.W 22nmF", _
 "MULU.W 22nmE", _
 "NEGC   26nmA", _
 "NEG    26nmB", _
 "NOP    00009", _
 "NOT    26nm7", _
 "OR     B7", _
 "OR.B   ACFdd", _
 "ROTL   14n04", _
 "ROTR   14n05", _
 "ROTCL  14n24", _
 "ROTCR  14n25", _
 "RTE    0002B", _
 "RTS    0000B", _
 "SETT   00018", _
 "SHAL   14n20", _
 "SHAR   14n21", _
 "SHLL   14n00", _
 "SHLR   14n01", _
 "SHLL2  14n08", _
 "SHLR2  14n09", _
 "SHLL8  14n18", _
 "SHLR8  14n19", _
 "SHLL16 14n28", _
 "SHLR16 14n29", _
 "SLEEP  0001B", _
 "STC    3", _
 "STC.L  3", _
 "STS    3", _ 
 "STS.L  3", _
 "SUB    23nm8", _
 "SUBC   23nmA", _
 "SUBV   23nmB", _
 "SWAP.B 26nm8", _
 "SWAP.W 26nm9", _
 "TAS.B  14n1B", _
 "TRAPA  AC3dd", _
 "TST    B8", _
 "TST.B  ACCdd", _
 "XOR    B9", _
 "XOR.B  ACEdd", _
 "XTRCT  22nmD", _
 "OPT    F", _
 "SETPC  4", _
 "DC.B   6", _
 "DC.W   7", _
 "DC.L   8", _
 "ORG    4", _
 "PAD    4", _
 "INCBIN 9", _
 "ALIGN.WG", _
 "ALIGN.LG", _
 "IMOV.L H", _
 "IDATA  I", _
 "END    5" _
}

if command$="" then
?:? "SH2 assembler `SUPERAS` by DamageX V0.93"
?:? "usage:"
? "SUPERAS sourcefile":?
end
end if

ifile=command$
ff1=freefile
open ifile for binary as #ff1
if lof(ff1)=0 then close #ff1:kill ifile:? "empty source file":end

z=1:if len(ifile)>4 then z=len(ifile)-3
for x=len(ifile) to z step -1
c=mid$(ifile,x,1)
if c="." then x=x-1:goto a56
next x
x=len(ifile)
a56:
ofile=mid$(ifile,1,x)+".bin"
lfile=mid$(ifile,1,x)+".log"


ff2=freefile
open ofile for binary as #ff2
if lof(ff2)>0 then close #ff2:kill ofile:open ofile for binary as #ff2

ff4=freefile
open lfile for output as #ff4
if lof(ff4)>0 then close #ff2:kill ofile:open lfile for output as #ff4

localu=0
localz=0
labs=0
l=0
pcaddr=0
fileaddr=1
frefs=0

' READ A LINE FROM INPUT FILE
a13:
l+=1
a55:
y=0:comment=0:lineend=0
a11:
if eof(ff1) then goto a12
get #ff1,,a
if a=9 then a=32        ' tab character
if a=10 then goto a10
if comment=1 then goto a11
if a=13 then goto a11
if a=32 then
if y=0 then goto a11
goto a15
end if
if a=asc(";") then comment=1:goto a11

' case desensitization (convert lower case to upper case)
if a>96 then if a<123 then a=a-32

il(y)=a
y+=1
if a=asc(":") then goto a14  ' labelname
if y=21 then goto a16
goto a11


a14:    ' add a label to the list
if y<3 then ? "what`s this colon doing on line ";l;"?":end
if y>21 then goto ltoolong
labelname=space$(20)
for x=0 to y-2
mid$(labelname,x+1,1)=chr$(il(x))
next x
if mid$(labelname,1,1)="@" then
mid$(labelname,19,1)=chr$((localz and 15)+48)
mid$(labelname,20,1)=chr$(((localz shr 4) and 15)+48)
localu=1
end if

' check for duplicate labelname
if labs>0 then
for x=0 to labs-1
if labelname=labelnames(x) then
if labeladdrs(x)<>&H7FFFFFFF then ? "duplicate label ";labelname;" on line ";l:end
labeladdrs(x)=pcaddr:goto a53
end if
next x
end if
labelnames(labs)=labelname
labeladdrs(labs)=pcaddr
labs+=1
a53:
if mid$(labelname,1,1)<>"@" then if localu=1 then localu=0:localz+=1
goto a55


a10:    ' end of line
lineend=1
if comment=1 then goto a13

a15:    ' try to identify the opcode/directive

' check string length
if y=0 then goto a13
if y>7 then goto a16
if y<2 then goto a16

' search database
for x=0 to 102
opname=opset(x)

for z=1 to 7
b=32
if (z-1)<y then b=il(z-1)
if b<>asc(mid$(opname,z,1)) then goto a17
next z

goto a18

a17:
next x
goto a16


a18:    ' identified the opcode, now fetch operands (if any)

? #ff4,"source line #";l;" binary offset ";fileaddr-1;" PC $";hex$(pcaddr);" ";mid$(opname,1,7)
                                         
c=mid$(opname,8,1)
if c="0" then goto a19
if c="5" then goto a12
if c="F" then goto a54

if c="G" then           ' align.x
z=(pcaddr and 1)
if mid$(opname,7,1)="L" then z=((4-pcaddr) and 3)
if z>0 then
a=255
for x=1 to z
put #ff2,,a:pcaddr+=1:fileaddr+=1
next x
end if
goto a54
end if

if c="I" then           ' IDATA
' first align to 32-bit boundary
z=((4-pcaddr) and 3)
if z>0 then
a=255
for x=1 to z
put #ff2,,a:pcaddr+=1:fileaddr+=1
next x
end if
' then look for instances of IMOV in frefs
if frefs>0 then
for x=0 to frefs-1
if frefmode(x)=2 then
frefmode(x)=3
imm=freflabn(x)
freflabn(x)=pcaddr
' copy longword to output binary
a=((imm shr 24) and 255)
put #ff2,,a
a=((imm shr 16) and 255)
put #ff2,,a
a=((imm shr 8) and 255)
put #ff2,,a
a=(imm and 255)
put #ff2,,a
fileaddr+=4
pcaddr+=4
end if
next x
end if
goto a54
end if

' argtype bit 0 - indirect
'         bit 1 - brackets/parenthesis
'         bit 2 - string
'         bit 3 - register 
'         bit 4 - r0
'         bit 5 - immediate/displacement
'         bit 6 - label
'         bit 7 - special register
'         bit 8 - a comma
'         bit 9 - pre decrement
'         bit 10 - post increment
'         bit 11 - hex
'         bit 12 - there were two parts to the last operand

o=0:argsok=0
oldarg=0
a25:
if lineend=1 then goto a26
if comment=1 then goto a26
argtype=0:e=0
esize(0)=0
esize(1)=0
a21:
if eof(ff1) then goto a28
get #ff1,,a
'? "a=";chr$(a);" ";a;" ";
if a=32 then goto a21
if a=9 then goto a21
if a=asc("$") then argtype=(argtype or 2048):imm=0:goto a21
if a=asc("-") then argtype=(argtype or 512):goto a21
if a=asc("+") then argtype=(argtype or 1024):goto a21
if (argtype and 2)=0 then if a=asc("@") then argtype=(argtype or 1):goto a21
if a=asc("[") then argtype=(argtype or 3):goto a21
if a=asc("(") then argtype=(argtype or 3):goto a21
if a=asc(")") then goto a21
if a=asc("]") then goto a21
if a=asc("#") then goto a21
if a=13 then goto a21
if a=10 then lineend=1:goto a49
if a=asc(";") then comment=1:goto a49

if a=34 then
if argtype>0 then ? "what is this junk before this quote on line ";l;"?":end
y=0
argtype=(argtype or 4)
a23:
get #ff1,,a
if a=34 then
if y=0 then ? "empty string on line ";l:end
' get one more byte in case it is a comma, indicating more operands
get #ff1,,a
if a=10 then lineend=1
if a=asc(";") then comment=1
argtype=4:goto a24
end if
il(y)=a
y+=1:if y>256 then ? "string too long on line ";l:end
goto a23
end if

if a=asc(",") then
if (argtype and 256) then ? "too many commas inside operand on line ";l:end

etype(e)=argtype
if (argtype and 2)=0 then goto a28

e+=1
argtype=0
goto a21
end if


' case desensitization (convert lower case to upper case)
if a>96 then if a<123 then a=a-32

estr(e,esize(e))=a
esize(e)+=1

if esize(e)>20 then ? "operand too long on line ";l:end

goto a21

a49:
etype(e)=argtype

a28:    ' identify the type of operand(s)
if esize(0)<1 then goto a26

for x=0 to e

y=0
argtype=etype(x)
a32:
a=estr(x,y)
y+=1

' IS IT A HEXADECIMAL NUMBER!?
if (argtype and 2048) then
argtype=(argtype or 32)
imm=0
a36:
if a>47 then if a<58 then b=a-48:goto a34
if a>64 then if a<71 then b=a-55:goto a34
? "thought there was a hex number, but something weird showed up on line ";l:end
a34:
imm=(imm shl 4)+b
a41:
if y=esize(x) then
if (argtype and 512) then imm=0-imm:argtype=(argtype and &HFDFF)
goto a33
end if
a=estr(x,y)
y+=1
goto a36
end if

' IS IT A DECIMAL NUMBER!?
if ((a>47) and (a<58)) then
argtype=(argtype or 32)
imm=0
a37:
if y=2 then if a=asc("X") then argtype=(argtype or 2048):imm=0:goto a41
if a>47 then if a<58 then b=a-48:goto a35
? "thought there was a decimal number, but something weird showed up on line ";l:end
a35:
imm=(imm*10)+b
if y=esize(x) then
if (argtype and 512) then imm=0-imm:argtype=(argtype and &HFDFF)
goto a33
end if
a=estr(x,y)
y+=1
goto a37
end if

' IS IT A REGISTER NUMBER!?
if esize(x)=1 then ? "there is something that appears to be a one-character-long label name on line ";l:end
if esize(x)>3 then goto a38
if a<>asc("R") then goto a38
b=estr(x,1)
if esize(x)=2 then
if b=48 then argtype=(argtype or 24):r=0:goto a33
if b>48 then if b<58 then argtype=(argtype or 8):r=b-48:goto a33
end if
if b<>49 then goto a38
b=estr(x,2)
if b>47 then if b<54 then argtype=(argtype or 8):r=b-38:goto a33

a38:
' IS IT A REGISTER NAME!?
if esize(x)>4 then goto a39
for w=0 to 6
for z=1 to 4
b=32
if (z-1)<esize(x) then b=estr(x,z-1)
if b<>asc(mid$(rnames(w),z,1)) then goto a40
next z
argtype=(argtype or 128)
sr=w:goto a33
a40:
next w

a39:
' FINE. IT IS A LABELNAME
argtype=(argtype or 64)

labelname=space$(20)
b=1
if (argtype and 3)=1 then mid$(labelname,1,1)="@":b=2
if esize(x)+b>21 then goto ltoolong
for z=0 to esize(x)-1
mid$(labelname,z+b,1)=chr$(estr(x,z))
next z
if mid$(labelname,1,1)="@" then
mid$(labelname,19,1)=chr$((localz and 15)+48)
mid$(labelname,20,1)=chr$(((localz shr 4) and 15)+48)
localu=1
end if

' check for existing labelname
if labs>0 then
for z=0 to labs-1
if labelname=labelnames(z) then ln=z:goto a33
next z
end if
labelnames(labs)=labelname
labeladdrs(labs)=&H7FFFFFFF
ln=labs
labs+=1

a33:
etype(x)=argtype
next x


a24:    ' now that an operand has been parsed, do something with it
o+=1

if c="1" then
if (argtype and 8) then
a=asc(mid$(opname,9,1))-48:if a>9 then a=a-7
b=r
a=(a shl 4)+b
put #ff2,,a
goto a42
end if
end if

if c="2" then
if o=1 then if (argtype and 8) then rs=r:goto a25
if o=2 then
if (argtype and 8) then
a=asc(mid$(opname,9,1))-48:if a>9 then a=a-7
b=r
a=(a shl 4)+b
put #ff2,,a
a=rs
goto a43
end if
end if
end if

if c="3" then
if o=1 then if (argtype and 128) then goto a25
if o=2 then
if (argtype and 8)=0 then goto a45
a=r
if (argtype and 513) then a+=&H40:sr+=7
put #ff2,,a
if sr=0 then a=&H0A:goto a46
if sr=1 then a=&H1A:goto a46
if sr=2 then a=&H12:goto a46
if sr=4 then a=&H2A:goto a46
if sr=5 then a=&H02:goto a46
if sr=6 then a=&H22:goto a46
if sr=7 then a=&H02:goto a46
if sr=8 then a=&H12:goto a46
if sr=9 then a=&H13:goto a46
if sr=11 then a=&H22:goto a46
if sr=12 then a=&H03:goto a46
if sr=13 then a=&H23:goto a46
end if
end if

if c="4" then
if (argtype and 32) then
' change the value of PC and optionally pad the binary to get there
if mid$(opname,1,3)<>"SET" then
if imm>pcaddr then
a=255
for x=pcaddr to imm-1
put #ff2,,a
fileaddr+=1
next x
end if
end if
pcaddr=imm
goto a22
end if
end if

if c="6" then
if argtype=4 then
' copy string to output binary
a47:
for x=0 to y-1
a=il(x)
put #ff2,,a
fileaddr+=1
pcaddr+=1
next x
argsok=1:goto a25
end if
if (argtype and 32) then
' copy byte to output binary
a=(imm and 255)
put #ff2,,a
fileaddr+=1
pcaddr+=1
argsok=1:goto a25
end if
end if

if c="7" then
if argtype=4 then goto a47
if (argtype and 32) then
' copy word to output binary
a=((imm shr 8) and 255)
put #ff2,,a
a=(imm and 255)
put #ff2,,a
fileaddr+=2
pcaddr+=2
argsok=1:goto a25
end if
end if

if c="8" then
if argtype=4 then goto a47
if (argtype and 32) then
' copy longword to output binary
a=((imm shr 24) and 255)
put #ff2,,a
a=((imm shr 16) and 255)
put #ff2,,a
a=((imm shr 8) and 255)
put #ff2,,a
a=(imm and 255)
put #ff2,,a
fileaddr+=4
pcaddr+=4
argsok=1:goto a25
end if
if (argtype and 64) then
' copy longword (label value) to output binary
frefmode(frefs)=0
frefaddr(frefs)=fileaddr
frefline(frefs)=l
freflabn(frefs)=ln
frefs+=1
put #ff2,,z
fileaddr+=4
pcaddr+=4
argsok=1:goto a25
end if
end if

if c="9" then 
' copy binary file to output binary
if (argtype and 4)=0 then ? "expected filename (in quotes) on line ";l:end
bfile=""
for x=0 to y-1
bfile=bfile+chr$(il(x))
next x
ff3=freefile
open bfile for binary as #ff3
x=lof(ff3)
if x=0 then ? "included file ";bfile;" is empty":end
pcaddr+=x
a27:
if x=0 then close #ff3:goto a22
if x>4093 then
get #ff3,,copybuf
put #ff2,,copybuf
fileaddr+=4096
x=x-4096
goto a27
end if
get #ff3,,a
put #ff2,,a
fileaddr+=1
x=x-1
goto a27
end if

if c="A" then
if (argtype and 32) then
a=asc(mid$(opname,9,1))-48:if a>9 then a=a-7
b=asc(mid$(opname,10,1))-48:if b>9 then b=b-7
a=(a shl 4)+b
put #ff2,,a
' write opcode with 8-bit immediate
a=(imm and 255)
goto a46
end if
end if

if c="B" then

if o=1 then
rs=r
if e=0 then oldarg=argtype:goto a25
oldarg=((etype(0) or etype(1)) or 4096)
goto a25
end if

a=asc(mid$(opname,9,1))-48:if a>9 then a=a-7

if e=0 then
if (((oldarg and 4097)=4097) and ((argtype and 8)=8)) then
' two-part operand on the left, register on the right
if (oldarg and 248)=24 then      ' (r0,r),r
s=(rs shl 4)+(r shl 8)
if a=3 then s+=12:goto a50
if a=4 then s+=13:goto a50
if a=5 then s+=14:goto a50
end if
if (oldarg and 232)=40 then      ' (d,r),r
s=(rs shl 4)
if r=0 then
if a=3 then s+=&H8400+(r shl 8)+(imm and 15):goto a50
if a=4 then s+=&H8500+(r shl 8)+((imm shr 1) and 15):goto a50
end if
if a=5 then s+=&H5000+(r shl 8)+((imm shr 2) and 15):goto a50
end if
if (oldarg and 160)=160 then
if ((r=0) and (sr=2)) then      ' (d,gbr),r0
if a=3 then s=&HC400+(imm and 255):goto a50
if a=4 then s=&HC500+((imm shr 1) and 255):goto a50
if a=5 then s=&HC600+((imm shr 2) and 255):goto a50
end if
end if
if (oldarg and 192)=192 then
if sr=3 then                        ' (d,pc),r
if a=4 then b=&H90+r:put #ff2,,b:goto a51
if a=5 then b=&HD0+r:put #ff2,,b:goto a51
if a=10 then if r=0 then b=&HC7:put #ff2,,b:a=5:goto a51        ' MOVA
goto a52
a51:
frefmode(frefs)=a
frefaddr(frefs)=fileaddr+1
frefline(frefs)=l
freflabn(frefs)=ln
frefbase(frefs)=pcaddr
frefs+=1
goto a46
end if
a52: end if
end if
' single operands on both sides
' two registers
if ((oldarg and argtype) and 8) then
b=a
if (argtype and 1) then b=b+24:if (argtype and 512) then b=b+12
if (oldarg and 1) then b=b+48:if (oldarg and 1024) then b=b+12
if b>71 then goto a45
s=(rs shl 4)+(r shl 8)
if b=0 then s+=&H300C:goto a50
if b=1 then s+=&H2009:goto a50
if b=2 then s+=&H3000:goto a50
if b=6 then s+=&H6003:goto a50
if b=7 then s+=&H200B:goto a50
if b=8 then s+=&H2008:goto a50
if b=9 then s+=&H200A:goto a50
if b=27 then s+=&H2000:goto a50
if b=28 then s+=&H2001:goto a50
if b=29 then s+=&H2002:goto a50
if b=51 then s+=&H6000:goto a50
if b=52 then s+=&H6001:goto a50
if b=53 then s+=&H6002:goto a50
if b=63 then s+=&H6004:goto a50
if b=64 then s+=&H6005:goto a50
if b=65 then s+=&H6006:goto a50
if b=39 then s+=&H2004:goto a50
if b=40 then s+=&H2005:goto a50
if b=41 then s+=&H2006:goto a50
end if
' immediate and one register
if (((oldarg and 32)=32) and ((argtype and 8)=8)) then
if a=0 then s=&H7000+(imm and 255)+(r shl 8):goto a50
if a=1 then s=&HC900+(imm and 255):goto a50
if a=2 then s=&H8800+(imm and 255):goto a50
if a=6 then s=&HE000+(imm and 255)+(r shl 8):goto a50
if a=7 then s=&HCB00+(imm and 255):goto a50
if a=8 then s=&HC800+(imm and 255):goto a50
if a=9 then s=&HCA00+(imm and 255):goto a50
end if
end if

' two-part operand on the right
if e=1 then
argtype=(etype(0) or etype(1))
if (oldarg and &HE9)=8 then
if (argtype and &HF8)=24 then     ' r,(r0,r)
s=(rs shl 4)+(r shl 8)
if a=3 then s+=4:goto a50
if a=4 then s+=5:goto a50
if a=5 then s+=6:goto a50
end if
if (argtype and 40)=40 then     ' r,(d,r)
if (oldarg and 16) then
s=(r shl 4)
if a=3 then s+=&H8000+(imm and 15):goto a50
if a=4 then s+=&H8100+((imm shr 1) and 15):goto a50
end if
if a=5 then s=&H1000+(rs shl 4)+(r shl 8)+((imm shr 2) and 15):goto a50
end if
if (((argtype and 160)=160) and (sr=2)) then     ' r0,(d,gbr)
if (oldarg and 16) then
if a=3 then s=&HC000+(imm and 255):goto a50
if a=4 then s=&HC100+((imm shr 1) and 255):goto a50
if a=5 then s=&HC200+((imm shr 2) and 255):goto a50
end if
end if
end if
end if

end if

if c="C" then
if o=1 then if (argtype and 8) then rs=r:oldarg=argtype:goto a25
if o=2 then
if (argtype and 128)=0 then goto a45
a=rs+&H40
put #ff2,,a
' decide opcode based on which instruction and register name were given
if (oldarg and 1025) then sr+=7
if sr=0 then a=&H0A:goto a46
if sr=1 then a=&H1A:goto a46
if sr=2 then a=&H1E:goto a46
if sr=4 then a=&H2A:goto a46
if sr=5 then a=&H0E:goto a46
if sr=6 then a=&H2E:goto a46
if sr=7 then a=&H06:goto a46
if sr=8 then a=&H16:goto a46
if sr=9 then a=&H17:goto a46
if sr=11 then a=&H26:goto a46
if sr=12 then a=&H07:goto a46
if sr=13 then a=&H27:goto a46
end if
end if

if c="D" then
if (argtype and 64) then
a=asc(mid$(opname,9,1))-48:if a>9 then a=a-7
b=asc(mid$(opname,10,1))-48:if b>9 then b=b-7
a=(a shl 4)+b
put #ff2,,a
' turn label address into 8-bit displacement
frefmode(frefs)=1
frefaddr(frefs)=fileaddr+1
frefline(frefs)=l
freflabn(frefs)=ln
frefbase(frefs)=pcaddr
frefs+=1
goto a46
end if
end if

if c="E" then
a=asc(mid$(opname,9,1))-48:if a>9 then a=a-7
if (argtype and 64) then
' turn label address into 12-bit displacement
frefmode(frefs)=a
frefaddr(frefs)=fileaddr
frefline(frefs)=l
freflabn(frefs)=ln
frefbase(frefs)=pcaddr
frefs+=1
put #ff2,,s
goto a31
end if
end if


if c="H" then
if o=1 then
if e=0 then oldarg=argtype:goto a25
else
' IMOV.L takes immediate and one register...
' MOV.L @(d,PC),Rn is the actual written opcode
if (((oldarg and 32)=32) and ((argtype and 8)=8)) then
b=&HD0+r:put #ff2,,b
frefmode(frefs)=2
frefaddr(frefs)=fileaddr+1
frefline(frefs)=l
freflabn(frefs)=imm
frefbase(frefs)=pcaddr
frefs+=1
goto a46
end if
end if
end if


a45:
? mid$(opname,1,7);" incorrect or missing operand on line ";l:end
'? "argtype=";argtype;" oldarg=";oldarg;" o=";o;" e=";e
'? "rs=";rs;" sr=";sr;" imm=";imm;" (hex) ";hex$(imm)
'? chr$(estr(0,0));chr$(estr(0,1));chr$(estr(0,2));chr$(estr(0,3)):end



a19:
' opcode with only one value (no operands)
a=asc(mid$(opname,9,1))-48:if a>9 then a=a-7
b=asc(mid$(opname,10,1))-48:if b>9 then b=b-7
a=(a shl 4)+b
put #ff2,,a
a42:
a=asc(mid$(opname,11,1))-48:if a>9 then a=a-7
a43:
b=asc(mid$(opname,12,1))-48:if b>9 then b=b-7
a=(a shl 4)+b

goto a46

a50:
a=((s shr 8) and 255)
put #ff2,,a
a=(s and 255)
a46:
put #ff2,,a

a31:
fileaddr+=2
pcaddr+=2

a22:
argsok=1
a26:
if argsok=0 then ? "missing argument on line ";l:end

a54:
if frefs>9998 then ? "overflowed label reference database :(":end

if lineend>0 then goto a13

comment=1       ' ignore any extraneous stuff on the rest of the line
goto a11


a12:    ' end of input

' (need to go back and fill in label references)

if frefs>0 then
for x=0 to frefs-1
fileaddr=frefaddr(x)
pcaddr=frefbase(x)
l=frefline(x)
z=frefmode(x)

if z=2 then ? "IMOV was used on line ";l;" but no IDATA area was specified afterward":end

if z=3 then
' 8-bit longword-aligned relative with absolute instead of label (IMOV)
y=freflabn(x)
if (y and 3)>0 then goto badref
y=y-((pcaddr+4) and &HFFFFFFFC)
if y>1020 then goto badref
a=((y and 1020) shr 2)
put #ff2,fileaddr,a
goto a57
end if

ln=freflabn(x)
y=labeladdrs(ln)

if y=&H7FFFFFFF then ? "label ";labelnames(ln);" undefined":end

if z=0 then
' longword absolute address
a=((y shr 24) and 255)
put #ff2,fileaddr,a:fileaddr+=1
a=((y shr 16) and 255)
put #ff2,fileaddr,a:fileaddr+=1
a=((y shr 8) and 255)
put #ff2,fileaddr,a:fileaddr+=1
a=(y and 255)
put #ff2,fileaddr,a:fileaddr+=1
end if

if z=1 then
' 8-bit word-aligned relative sign-extended
if (y and 1) then goto badref
y=y-(pcaddr+4)
if ((y>254) and (y<&HFFFFFF00)) then goto badref
a=((y and 510) shr 1)
put #ff2,fileaddr,a
end if

if z=4 then
' 8-bit word-aligned relative
if (y and 1) then goto badref
y=y-(pcaddr+4)
if y>510 then goto badref
a=((y and 510) shr 1)
put #ff2,fileaddr,a
end if

if z=5 then
' 8-bit longword-aligned relative
if (y and 3)>0 then goto badref
y=y-((pcaddr+4) and &HFFFFFFFC)
if y>1020 then goto badref
a=((y and 1020) shr 2)
put #ff2,fileaddr,a
end if

if ((z=10) or (z=11)) then
' 12-bit word-aligned relative sign-extended
if (y and 1) then goto badref
y=y-(pcaddr+4)
if ((y>4094) and (y<&HFFFFF000)) then goto badref
b=((y and 7680) shr 9)
a=(z shl 4)+b
put #ff2,fileaddr,a
a=((y and 510) shr 1)
put #ff2,,a
end if

a57:
next x
end if


a1000:

if labs>0 then
? #ff4,"labels (";labs;"):"
for x=0 to labs-1
? #ff4,labelnames(x);"   $";hex$(labeladdrs(x))
next x
end if

end


a16:
? "parsing failure on line ";l:end

ltoolong:
? "label name too long on line ";l:end

badref:
? "invalid address reference on line ";l:end


